{{- $variant := or .variant "mainline" -}}
{{- $architecture := or .architecture "arm64" -}}
{{- $cdimagesmirror := or .cdimagesmirror "http://cdimage.ubuntu.com" -}}
{{- $additional_apt_repos := or .additional_apt_repos "http://repo.ubports.com/ focal_-_pine 2001" -}}

---

architecture: {{ $architecture }}
actions:
  - action: recipe
    description: Setup base rootfs
    recipe: bases/focal.yaml
    variables:
      architecture: {{ $architecture }}
      cdimagesmirror: {{ $cdimagesmirror }}
      skip_remove_apt_user: true
      additional_apt_repos: {{ $additional_apt_repos }}

  - action: recipe
    description: Create Ubuntu Touch rootfs
    recipe: ubuntu-touch-common.yaml
    variables:
      architecture: {{ $architecture }}
      variant: {{ $variant }}
      # TODO: make PinePhone image generation parameterized.
      ut_version_major: "focal"
      additional_package: >-
        adbd
        sshfs
        git
        mesa-v*-drivers
        waydroid
        waydroid-sensors
        usb-modeswitch
        usb-moded
        libcurl3-nss
        libgpiod2
        build-essential
        devscripts
        equivs
        alsa-ucm-conf
        iio-sensor-proxy
        mobile-usb-networking
        systemd-repart
        u-boot-tools
        linux-firmware
        initramfs-tools-ubuntu-touch
        u-boot-menu
        ubuntu-touch-config-common

  - action: overlay
    source: pine64/overlay
    description: Adding Pine overlay
    destination: /

  - action: run
    description: fix alsa
    chroot: true
    command: rm -r /usr/lib/systemd/user/pulseaudio.service.d/

  - action: run
    description: create mali group
    chroot: true
    command: /sbin/groupadd mali && usermod -aG mali phablet

  - action: download
    description: Fetch latest kernel ci build
    url: https://gitlab.com/ook37/linux/-/jobs/artifacts/okpine-6.5-ut/download?job=build_phone
    name: kernel
    filename: kernel.zip
    unpack: true
    compression: zip

  - action: overlay
    description: Copying kernel to rootfs
    origin: kernel
    source: .
    destination: /var/tmp/

  - action: run
    chroot: true
    description: Installing kernel on rootfs
    label: dpkg
    command: dpkg -i /var/tmp/*.deb && /bin/rm /var/tmp/* -r

  - action: run
    chroot: true
    script: ../scripts/try-depmod-installed.sh

  - action: run
    chroot: true
    description: Ensure waydroid is enabled and userdata resizes correctly
    command: /bin/systemctl enable waydroid-container.service && /bin/systemctl enable resizefs.service
